Kepler - Bug #5655

sdm spa Repeat is a duplicate of a Ptolemy actor
08/06/2012 04:39 PM - Christopher Brooks

Status: Resolved Start date: 08/06/2012
Priority: Normal Due date:

Assignee: jianwu jianwu % Done: 0%
Category: actors Estimated time: 0.00 hour
Target version: 24.0 Spent time: 0.00 hour
Bugzilla-ld: 5655

Description

Jactors/src/org/sdm/spa/Repeat.java
FIXME: No documentation? If possible, Deprecate and extend
ptolemy/src/ptolemy/domains/sdf/lib/Repeat.java

History

#1 - 08/07/2012 01:56 PM - jianwu jianwu

These two actors have different ports and parameters. Ptolemy one has one input port and two parameters; Sdm one has two input ports and no
parameter.

#2 - 08/07/2012 02:12 PM - Christopher Brooks

Kepler actors/src/org/sdm/spa/Repeat.java has:
public TypedIOPort portOutput;

public TypedlOPort portinput;

public TypedIOPort portNum;

Ptolemy sdf/lib/Repeat has:

/** The repetition factor. It is of type integer and has a default
*/

public Parameter numberOfTimes;

*

value of 2. It must be greater than zero.

/** The number of tokens in a block. It is of type integer and has a
* default value of 1. It must be greater than zero.
o/

public Parameter blockSize;
input and output ports from SDFTransformer
The way | would handle is to modify Ptolemy's sdf/lib/Repeat.java so that
numberOfTimes is a PortParmeter. See actor/lib/Ramp.java for an example.
Basically, with PortParameters, the update() method should be called once.
Then, modify the Kepler moml/filter classes to change the name of the actor

and the name of the ports. There could be some trickyness here, you probably
want to change the name of the ports first.

#3 - 09/11/2012 01:57 PM - jianwu jianwu
| dig more into the two actors and found more differences:

1) sdf/lib/Repeat works with SDF, not PN (no output with PN director); org/sdm/spa/Repeat works with PN, not SDF (only 1 can be set for SDF
iterations parameter)

2) sdf/lib/Repeat has a parameter called 'blockSize' and can accept a serial of input tokens (e.g. from Ramp actor); org/sdm/spa/Repeat doesn't has
such as parameter, and only the first token is processed if a serial of input tokens are sent to portlnput port.

| don't know why org/sdm/spa/Repeat is built. My guess is that it tries to have repeat behavior with PN.

With such big differences, it might not be a good choice to merge them. Maybe we should updates their documents, having a 'see also’ link to the
other repeat actor?

#4 - 09/11/2012 02:05 PM - Christopher Brooks

Could you add the sdf/lib/Repeat PN test case as an attachment?
I'll take a look and possibly fold it in to the Ptolemy Il tests.
Maybe the thing to do is update the sdm/spa/Repeat documentation
and then retarget this to 2.X?

The Ptolemy documentation should probably not be updated to mention Kepler until we verify that Repeat will not work in PN.

#9 - 09/11/2012 02:11 PM - jianwu jianwu

| updated the all four workflows. I'll update Kepler repeat actor documentation and re-target it to 2.X.

#10 - 09/11/2012 07:20 PM - Christopher Brooks

ptolemy-repeat-actor-in-PN at

http://bugzilla.ecoinformatics.org/attachment.cgi?id=434
will work if the FiringCountLimit of the Const is set to 2 instead of 1.

If FiringCountLimit is set to 1, then under PN the Const actor fires
only once, which means the Repeat actor gets only one token instead
of the two that it requires.

#11 - 09/12/2012 11:00 AM - jianwu jianwu

Hi Christopher, you are right. Either setting FiringCountLimit of Const actor to be 2, or setting blockSize of Repeat actor to be 1 will work. If | just
replace the PN with SDF, the same workflow will throw an exception of Repeat when | tried to run it. But PN director doesn't throw an exception.
That's why | thought repeat actor doesn't work with PN. Also its class name (ptolemy.domains.sdf.lib.Repeat) seams it might only work with SDF. :)

After discussion with Dan, | think the best way now is only updating ptolemy/domains/sdf/lib/Repeat.java by changing its numberOfTimes from
parameter to portparameter. It will cover all the behaviors we need for Repeat. As for sdm/spa/Repeat.java, since its behavior is a little different when
using SDF (it only output 1). | will comment the code to be deprecated. Old workflows using this actor can still be opened and run. And since
sdm/spa/Repeat.java is not in the actor tree, new workflows will not use it.

#12 - 09/18/2012 04:04 PM - jianwu jianwu

after discussion, we will go with comment 11.

#13 - 09/20/2012 10:39 AM - jianwu jianwu

The changes are done based on comment 11. The bug is fixed at kepler version 30712 and ptolemy version 64693.

#14 - 03/27/2013 02:31 PM - Redmine Admin
Original Bugzilla ID was 5655

Files

ptolemy-repeat-demo-in-PN.xml 23.5 KB 09/11/2012 jianwu jianwu
kepler-repeat-demo-in-SDF.xml 35 KB 09/11/2012 jianwu jianwu
ptolemy-repeat-demo-in-SDF.xml 33.9KB 09/11/2012 jilanwu jianwu
kepler-repeat-demo-PN.xml 26.2 KB 09/11/2012 jianwu jianwu
